<?php

class Gallery extends Controller {

    function __construct($name) {

        parent::__construct($name);

        $this->checkAdminLogin();

        $this->view->css[] = CSS . 'bootstrap.css';

        $this->view->css[] = CSS . 'layout.css';

        $this->view->js[] = JS . 'bootstrap.js';

        $this->view->js[] = URL . 'public/ckeditor/ckeditor.js';

        $this->view->title = 'Emaar';

        $this->view->metaKeywords = '';

        $this->view->metaDescription = '';
    }

    public function Addgallery() {


        if (isset($_POST['submitg'])) {

//            $this->img = $_FILES['file']['name'];
//            $this->img = $_FILES['file']['size'];

            if ($_FILES['file']['error'] === 0) {
                $this->img = $_FILES['file']['name'];
                
                $this->arr = explode('.', $this->img);

                $this->rand = rand();

                $this->newimg = $this->rand . '.' . end($this->arr); //print_r($this->arr);
                $ext = end($this->arr);
                
                $target_path = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/';
                $target_path2 = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/thumb_gallery/';
                $tmp_name = $_FILES["file"]["tmp_name"];
                
                $target_path = $target_path . basename($this->newimg);
                $target_path2 = $target_path2 . basename($this->newimg);
               
                list($width, $height) = getimagesize($tmp_name);
                if ($width > 1200) {
                    $this->resize(1200, $target_path, $tmp_name);

                    // ----------thumbnail generation----------

                    $this->resize(370, $target_path2, $tmp_name);
                } else {
                    $this->resize(370, $target_path2, $tmp_name);
                    $t = move_uploaded_file($tmp_name, $target_path);
                }
                $this->model->insertgallery($_POST, $this->newimg);
               
            
            } else {
                
            }
       
        }

        $this->view->getgallery = $this->model->getgallery();
        $this->view->renderAdmin('Gallery/gallery_add');
    }

    function resize($newWidth, $targetFile, $originalFile) {

        $info = getimagesize($originalFile);
        $mime = $info['mime'];

        switch ($mime) {
            case 'image/jpeg':
                $image_create_func = 'imagecreatefromjpeg';
                $image_save_func = 'imagejpeg';
                $new_image_ext = 'jpg';
                break;

            case 'image/png':
                $image_create_func = 'imagecreatefrompng';
                $image_save_func = 'imagepng';
                $new_image_ext = 'png';
                break;

            case 'image/gif':
                $image_create_func = 'imagecreatefromgif';
                $image_save_func = 'imagegif';
                $new_image_ext = 'gif';
                break;

            default:
                throw new Exception('Unknown image type.');
        }

        $img = $image_create_func($originalFile);
        list($width, $height) = getimagesize($originalFile);

        $newHeight = ($height / $width) * $newWidth;
        $tmp = imagecreatetruecolor($newWidth, $newHeight);
        imagecopyresampled($tmp, $img, 0, 0, 0, 0, $newWidth, $newHeight, $width, $height);

        if (file_exists($targetFile)) {
            unlink($targetFile);
        }
        $image_save_func($tmp, "$targetFile");
    }

    public function editgallery($id) {

        $this->view->getgallery = $this->model->getgalleryByid($id);
        $this->view->renderAdmin('Gallery/gallery_edit');
    }

    public function updategallery() {
        if (isset($_POST['submitg'])) {
            if (($_FILES['image']['error'] == 0)) {
                $this->img = $_FILES['image']['name'];

                $this->arr = explode('.', $this->img);
                $this->rand = rand();
                $this->newimg = $this->rand . '.' . end($this->arr);

                $target_path = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/';
                $target_path2 = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/thumb_gallery/';

                
                $tmp_name = $_FILES["image"]["tmp_name"];
                $target_path = $target_path . basename($this->newimg);
                $target_path2 = $target_path2 . basename($this->newimg);
                
                //-----extension checking---


                list($width, $height) = getimagesize($tmp_name);
                if ($width > 1200) {
                    $this->resize(1200, $target_path, $tmp_name);

                    // ----------thumbnail generation----------

                    $this->resize(370, $target_path2, $tmp_name);
                } else {
                    $this->resize(370, $target_path2, $tmp_name);
                    $t = move_uploaded_file($tmp_name, $target_path);
                }

                
            } else {
                
            }
            
        }
        $this->model->getupdategallery($_POST, $this->newimg);
        $this->view->getgallery = $this->model->getgallery();
        header('Location:'.URL.'Gallery/Addgallery');
    }

    public function deletegallery($id) {
        $this->view->try = $this->model->getgalleryimg($id);

        $img = $this->view->try[0]['file'];
        $path = $target_path = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/' . $img;
        $path1 = $target_path2 = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/gallery/thumb_gallery/' . $img;

        
        if (is_file($path)) {
            unlink($path);
            if (is_file($path1)) {
                unlink($path1);
            }
        }

        $this->model->getdeleteimggallery($id);
        header('Location:'.URL.'Gallery/Addgallery');
    }

    public function image() {

        if (isset($_POST['submitg'])) {

            $name_array = $FILES['image']['name'];
            $tmp_array = $FILES['image']['file_name'];
            $type_array = $FILES['image']['type'];
            $size_array = $FILES['image']['size'];
            $error_array = $_FILES['image']['error'];

            if (!empty($tmp_array)) {
                $i = 0;
                foreach ($tmp_array as $tmp => $file) {

                    if (empty($error_array)) {

                        $file_name = $this->upload_images($file, $type_array[$tmp]);

                        $this->model->image_upload($file_name);
                    }
                }
            }
        }
    }

    public function uploadimage($file, $type) {

        $target_path = $_SERVER['DOCUMENT_ROOT'] . '/emaar/manage/public/uploads/news/';

        $exp = explode("/", $type);
        $ext = end($exp);
        $file_name = '';

        $new_name = rand() . "_" . time() . "." . $ext;
        list($height, $width) = getimagesize($file);
        if ($width > 1200 && $height > 800) {
            $filename = $this->resize(600, $target_path, $file);
            
            echo '<script> alert("Image has been resized and Uploaded successfully");</script>';
        } else {
            if (move_uploaded_file($file, $target_path)) {

                echo '<script> alert("Uploaded successfully");</script>';

                $filename = $new_name;
                
            } else {
                
                echo '<script> alert(" Image not uploaded");</script>';
                
            }
        }
        return $filename;
    }
}
